=== debian/changelog ===
yade (0.80.1-2) unstable; urgency=low

  * [9ddf3c4] Handle ipython 0.13. (Closes: #680285)

 -- Anton Gladky <gladky.anton@gmail.com>  Wed, 04 Jul 2012 21:41:22 +0200

yade (0.80.1-1) unstable; urgency=low

  * [64a8de3] Imported Upstream version 0.80.1

 -- Anton Gladky <gladky.anton@gmail.com>  Tue, 29 May 2012 23:20:12 +0200

yade (0.80.0-3) unstable; urgency=low

  * [fd11426] Add minimal version for dpkg-dev (>= 1.16.2).
  * [2259a3f] Fix FTBFS against gcc-4.7. (Closes: #672126)

 -- Anton Gladky <gladky.anton@gmail.com>  Wed, 09 May 2012 20:34:48 +0200

yade (0.80.0-2) unstable; urgency=low

  * [17ac3c8] Recover fix_FTBFS_on_KFreeBSD.patch.

 -- Anton Gladky <gladky.anton@gmail.com>  Sat, 05 May 2012 06:57:35 +0200

yade (0.80.0-1) unstable; urgency=low

  * [714d23e] Enable cgal-feature.
  * [f5fe5b4] Remove patches, applied by upstream.
  * [2d168c8] Use compat-level 8.
  * [0b404ca] Imported Upstream version 0.80.0
  * [19b9ce5] Re-enable PDF-generation. (Closes: #651220)

 -- Anton Gladky <gladky.anton@gmail.com>  Wed, 02 May 2012 23:22:19 +0200
